Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/tranxt.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 2023)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 2024)
@@ -28,6 +28,6 @@
    USE dynspg_oce      ! surface     pressure gradient variables
    USE dynhpg          ! hydrostatic pressure gradient 
-   USE trdmod_oce      ! ocean variables trends
-   USE trdmod          ! ocean active tracers trends 
+   USE trdmod_oce      ! ocean space and time domain variables 
+   USE trdtra          ! ocean active tracers trends 
    USE phycst
    USE obctra          ! open boundary condition (obc_tra routine)
@@ -36,12 +36,15 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE prtctl          ! Print control
+   USE traswp          ! swap array
    USE agrif_opa_update
    USE agrif_opa_interp
-   USE obc_oce 
+   USE obc_oce
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   tra_nxt    ! routine called by step.F90
+   PUBLIC   tra_nxt       ! routine called by step.F90
+   PUBLIC   tra_nxt_fix   ! to be used in trcnxt
+   PUBLIC   tra_nxt_vvl   ! to be used in trcnxt
 
    REAL(wp), DIMENSION(jpk) ::   r2dt_t   ! vertical profile time step, =2*rdttra (leapfrog) or =rdttra (Euler)
@@ -81,11 +84,10 @@
       !!              - (ta,sa) time averaged (t,s)   (ln_dynhpg_imp = T)
       !!----------------------------------------------------------------------
-      USE oce, ONLY :    ztrdt => ua   ! use ua as 3D workspace   
-      USE oce, ONLY :    ztrds => va   ! use va as 3D workspace   
-      !!
       INTEGER, INTENT(in) ::   kt    ! ocean time-step index
       !!
       INTEGER  ::   jk    ! dummy loop indices
       REAL(wp) ::   zfact ! temporary scalars
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ztrdt, ztrds
+
       !!----------------------------------------------------------------------
 
@@ -98,7 +100,10 @@
       ! Update after tracer on domain lateral boundaries
       ! 
-      CALL lbc_lnk( ta, 'T', 1. )      ! local domain boundaries  (T-point, unchanged sign)
-      CALL lbc_lnk( sa, 'T', 1. )
-      !
+      CALL lbc_lnk( tsa(:,:,:,jp_tem), 'T', 1. )      ! local domain boundaries  (T-point, unchanged sign)
+      CALL lbc_lnk( tsa(:,:,:,jp_sal), 'T', 1. )
+      !
+#if defined key_obc || defined key_bdy || defined key_agrif
+      CALL tra_unswap
+#endif
 #if defined key_obc
       IF( lk_obc )   CALL obc_tra( kt )  ! OBC open boundaries
@@ -110,4 +115,7 @@
       CALL Agrif_tra                   ! AGRIF zoom boundaries
 #endif
+#if defined key_obc || defined key_bdy || defined key_agrif
+      CALL tra_swap
+#endif
  
       ! set time step size (Euler/Leapfrog)
@@ -117,17 +125,21 @@
 
       ! trends computation initialisation
-      IF( l_trdtra ) THEN              ! store now fields before applying the Asselin filter
-         ztrdt(:,:,:) = tn(:,:,:)      
-         ztrds(:,:,:) = sn(:,:,:)
+      IF( l_trdtra )   THEN                    !* store now fields before applying the Asselin filter
+         ALLOCATE( ztrdt(jpi,jpj,jpk) )   ;    ztrdt(:,:,:) = tsn(:,:,:,jp_tem) 
+         ALLOCATE( ztrds(jpi,jpj,jpk) )   ;    ztrds(:,:,:) = tsn(:,:,:,jp_sal)
       ENDIF
 
       ! Leap-Frog + Asselin filter time stepping
-      IF( lk_vvl )   THEN   ;   CALL tra_nxt_vvl( kt )      ! variable volume level (vvl)
-      ELSE                  ;   CALL tra_nxt_fix( kt )      ! fixed    volume level
+      IF( lk_vvl )   THEN   ;   CALL tra_nxt_vvl( kt , nit000,           &
+                                &                 tsb, tsn   , tsa, jpts )      ! variable volume level (vvl)
+      ELSE                  ;   CALL tra_nxt_fix( kt , nit000,           &
+                                &                 tsb, tsn   , tsa, jpts )      ! fixed    volume level
       ENDIF
 
 #if defined key_agrif
+      CALL tra_unswap
       ! Update tracer at AGRIF zoom boundaries
       IF( .NOT.Agrif_Root() )    CALL Agrif_Update_Tra( kt )      ! children only
+      CALL tra_swap
 #endif      
 
@@ -136,18 +148,20 @@
          DO jk = 1, jpkm1
             zfact = 1.e0 / r2dt_t(jk)             
-            ztrdt(:,:,jk) = ( tb(:,:,jk) - ztrdt(:,:,jk) ) * zfact
-            ztrds(:,:,jk) = ( sb(:,:,jk) - ztrds(:,:,jk) ) * zfact
+            ztrdt(:,:,jk) = ( tsb(:,:,jk,jp_tem) - ztrdt(:,:,jk) ) * zfact
+            ztrds(:,:,jk) = ( tsb(:,:,jk,jp_sal) - ztrds(:,:,jk) ) * zfact
          END DO
-         CALL trd_mod( ztrdt, ztrds, jptra_trd_atf, 'TRA', kt )
+         CALL trd_tra( kt, 'TRA', jp_tem, jptra_trd_atf, ztrdt )
+         CALL trd_tra( kt, 'TRA', jp_sal, jptra_trd_atf, ztrds )
+         DEALLOCATE( ztrdt )      ;     DEALLOCATE( ztrds ) 
       END IF
 
       !                        ! control print
-      IF(ln_ctl)   CALL prt_ctl( tab3d_1=tn, clinfo1=' nxt  - Tn: ', mask1=tmask,   &
-         &                       tab3d_2=sn, clinfo2=       ' Sn: ', mask2=tmask )
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=tsn(:,:,:,jp_tem), clinfo1=' nxt  - Tn: ', mask1=tmask,   &
+         &                       tab3d_2=tsn(:,:,:,jp_sal), clinfo2=       ' Sn: ', mask2=tmask )
       !
    END SUBROUTINE tra_nxt
 
-
-   SUBROUTINE tra_nxt_fix( kt )
+   SUBROUTINE tra_nxt_fix( kt   , kit000,              &
+      &                    ptrab, ptran , ptraa, kjpt  )
       !!----------------------------------------------------------------------
       !!                   ***  ROUTINE tra_nxt_fix  ***
@@ -171,12 +185,16 @@
       !!              - (ta,sa) time averaged (t,s)   (ln_dynhpg_imp = T)
       !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt    ! ocean time-step index
-      !!
-      INTEGER  ::   ji, jj, jk   ! dummy loop indices
-      REAL(wp) ::   ztm, ztf     ! temporary scalars
-      REAL(wp) ::   zsm, zsf     !    -         -
-      !!----------------------------------------------------------------------
-
-      IF( kt == nit000 ) THEN
+      INTEGER , INTENT(in   )                               ::  kt            ! ocean time-step index
+      INTEGER , INTENT(in   )                               ::  kit000        ! first time-step index
+      INTEGER , INTENT(in   )                               ::  kjpt            ! number of tracers
+      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::  ptrab  ! before tracer fields
+      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::  ptran  ! now tracer fields
+      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::  ptraa         ! tracer trend
+      !!
+      INTEGER  :: ji, jj, jk, jn   ! dummy loop indices
+      REAL(wp) :: ztm, ztf     ! temporary scalars
+      !!----------------------------------------------------------------------
+
+      IF( kt == kit000 ) THEN
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) 'tra_nxt_fix : time stepping'
@@ -188,27 +206,26 @@
          !                                           ! ----------------------- !
          !
-         IF( neuler == 0 .AND. kt == nit000 ) THEN        ! Euler time-stepping at first time-step
-            DO jk = 1, jpkm1                              ! (only swap)
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     tn(ji,jj,jk) = ta(ji,jj,jk)                                           ! tb <-- tn
-                     sn(ji,jj,jk) = sa(ji,jj,jk)
+         IF( neuler == 0 .AND. kt == kit000 ) THEN        ! Euler time-stepping at first time-step
+            !                                             ! (only swap)
+            DO jn = 1, kjpt
+               DO jk = 1, jpkm1                              
+                  DO jj = 1, jpj
+                     DO ji = 1, jpi
+                        ptran(ji,jj,jk,jn) = ptraa(ji,jj,jk,jn)     ! ptrab <-- ptran
+                     END DO
                   END DO
                END DO
             END DO
          ELSE                                             ! general case (Leapfrog + Asselin filter
-            DO jk = 1, jpkm1
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     ztm = 0.25 * ( ta(ji,jj,jk) + 2.* tn(ji,jj,jk) + tb(ji,jj,jk) )       ! mean t
-                     zsm = 0.25 * ( sa(ji,jj,jk) + 2.* sn(ji,jj,jk) + sb(ji,jj,jk) )
-                     ztf = atfp * ( ta(ji,jj,jk) - 2.* tn(ji,jj,jk) + tb(ji,jj,jk) )       ! Asselin filter on t 
-                     zsf = atfp * ( sa(ji,jj,jk) - 2.* sn(ji,jj,jk) + sb(ji,jj,jk) )
-                     tb(ji,jj,jk) = tn(ji,jj,jk) + ztf                                     ! tb <-- filtered tn 
-                     sb(ji,jj,jk) = sn(ji,jj,jk) + zsf
-                     tn(ji,jj,jk) = ta(ji,jj,jk)                                           ! tn <-- ta
-                     sn(ji,jj,jk) = sa(ji,jj,jk)
-                     ta(ji,jj,jk) = ztm                                                    ! ta <-- mean t
-                     sa(ji,jj,jk) = zsm
+            DO jn = 1, kjpt
+               DO jk = 1, jpkm1
+                  DO jj = 1, jpj
+                     DO ji = 1, jpi
+                        ztm = 0.25 * ( ptraa(ji,jj,jk,jn) + 2.* ptran(ji,jj,jk,jn) + ptrab(ji,jj,jk,jn) )  ! mean ptra
+                        ztf = atfp * ( ptraa(ji,jj,jk,jn) - 2.* ptran(ji,jj,jk,jn) + ptran(ji,jj,jk,jn) )  ! Asselin filter on ptra 
+                        ptrab(ji,jj,jk,jn) = ptran(ji,jj,jk,jn) + ztf                                      ! ptrab <-- filtered ptran 
+                        ptran(ji,jj,jk,jn) = ptraa(ji,jj,jk,jn)                                            ! ptran <-- ptraa
+                        ptraa(ji,jj,jk,jn) = ztm                                                           ! ptraa <-- mean ptra
+                     END DO
                   END DO
                END DO
@@ -219,27 +236,28 @@
          !                                           ! ----------------------- !
          !
-         IF( neuler == 0 .AND. kt == nit000 ) THEN        ! Euler time-stepping at first time-step
-            DO jk = 1, jpkm1
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     tn(ji,jj,jk) = ta(ji,jj,jk)                                           ! tn <-- ta
-                     sn(ji,jj,jk) = sa(ji,jj,jk)
+         IF( neuler == 0 .AND. kt == kit000 ) THEN        ! Euler time-stepping at first time-step
+            DO jn = 1, kjpt
+               DO jk = 1, jpkm1
+                  DO jj = 1, jpj
+                     DO ji = 1, jpi
+                        ptran(ji,jj,jk,jn) = ptraa(ji,jj,jk,jn)                                             ! ptran <-- ptraa
+                     END DO
                   END DO
                END DO
             END DO
          ELSE                                             ! general case (Leapfrog + Asselin filter
-            DO jk = 1, jpkm1
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     ztf = atfp * ( ta(ji,jj,jk) - 2.* tn(ji,jj,jk) + tb(ji,jj,jk) )       ! Asselin filter on t 
-                     zsf = atfp * ( sa(ji,jj,jk) - 2.* sn(ji,jj,jk) + sb(ji,jj,jk) )
-                     tb(ji,jj,jk) = tn(ji,jj,jk) + ztf                                     ! tb <-- filtered tn 
-                     sb(ji,jj,jk) = sn(ji,jj,jk) + zsf
-                     tn(ji,jj,jk) = ta(ji,jj,jk)                                           ! tn <-- ta
-                     sn(ji,jj,jk) = sa(ji,jj,jk)
+            DO jn = 1, kjpt
+               DO jk = 1, jpkm1
+                  DO jj = 1, jpj
+                     DO ji = 1, jpi
+                        ztf = atfp * ( ptraa(ji,jj,jk,jn) - 2.* ptran(ji,jj,jk,jn) + ptrab(ji,jj,jk,jn) )       ! Asselin filter on t 
+                        ptrab(ji,jj,jk,jn) = ptran(ji,jj,jk,jn) + ztf                                     ! ptrab <-- filtered ptran 
+                        ptran(ji,jj,jk,jn) = ptraa(ji,jj,jk,jn)                                           ! ptran <-- ptraa
+                     END DO
                   END DO
                END DO
             END DO
          ENDIF
+         !
       ENDIF
       !
@@ -247,5 +265,6 @@
 
 
-   SUBROUTINE tra_nxt_vvl( kt )
+   SUBROUTINE tra_nxt_vvl( kt   , kit000,              &
+      &                    ptrab, ptran , ptraa, kjpt  )
       !!----------------------------------------------------------------------
       !!                   ***  ROUTINE tra_nxt_vvl  ***
@@ -271,66 +290,67 @@
       !!              - (ta,sa) time averaged (t,s)   (ln_dynhpg_imp = T)
       !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt    ! ocean time-step index
+      INTEGER , INTENT(in   )                               ::  kt            ! ocean time-step index
+      INTEGER , INTENT(in   )                               ::  kit000        ! first time-step index
+      INTEGER , INTENT(in   )                               ::  kjpt            ! number of tracers
+      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::  ptrab  ! before tracer fields
+      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::  ptran  ! now tracer fields
+      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::  ptraa         ! tracer trend
       !!     
-      INTEGER  ::   ji, jj, jk             ! dummy loop indices
+      INTEGER  ::   ji, jj, jk, jn             ! dummy loop indices
       REAL(wp) ::   ztm , ztc_f , ztf , ztca, ztcn, ztcb   ! temporary scalar
-      REAL(wp) ::   zsm , zsc_f , zsf , zsca, zscn, zscb   !    -         -
       REAL(wp) ::   ze3mr, ze3fr                           !    -         -
       REAL(wp) ::   ze3t_b, ze3t_n, ze3t_a, ze3t_f         !    -         -
       !!----------------------------------------------------------------------
 
-      IF( kt == nit000 ) THEN
+      IF( kt == kit000 ) THEN
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) 'tra_nxt_vvl : time stepping'
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
       ENDIF
-
+      !
       !                                              ! ----------------------- !
       IF( ln_dynhpg_imp ) THEN                       ! semi-implicite hpg case !
          !                                           ! ----------------------- !
          !
-         IF( neuler == 0 .AND. kt == nit000 ) THEN        ! Euler time-stepping at first time-step
-            DO jk = 1, jpkm1                              ! (only swap)
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     tn(ji,jj,jk) = ta(ji,jj,jk)                    ! tn <-- ta
-                     sn(ji,jj,jk) = sa(ji,jj,jk)
+         IF( neuler == 0 .AND. kt == kit000 ) THEN        ! Euler time-stepping at first time-step
+            DO jn = 1, kjpt                               ! (only swap)
+               DO jk = 1, jpkm1                              
+                  DO jj = 1, jpj
+                     DO ji = 1, jpi
+                        ptran(ji,jj,jk,jn) = ptraa(ji,jj,jk,jn)                    ! tn <-- ta
+                     END DO
                   END DO
                END DO
             END DO
          ELSE
-            DO jk = 1, jpkm1
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     ze3t_b = fse3t_b(ji,jj,jk)
-                     ze3t_n = fse3t_n(ji,jj,jk)
-                     ze3t_a = fse3t_a(ji,jj,jk)
-                     !                                         ! tracer content at Before, now and after
-                     ztcb = tb(ji,jj,jk) *  ze3t_b   ;   zscb = sb(ji,jj,jk) * ze3t_b
-                     ztcn = tn(ji,jj,jk) *  ze3t_n   ;   zscn = sn(ji,jj,jk) * ze3t_n
-                     ztca = ta(ji,jj,jk) *  ze3t_a   ;   zsca = sa(ji,jj,jk) * ze3t_a
-                     !
-                     !                                         ! Asselin filter on thickness and tracer content
-                     ze3t_f = atfp * ( ze3t_a - 2.* ze3t_n + ze3t_b )
-                     ztc_f  = atfp * ( ztca   - 2.* ztcn   + ztcb   ) 
-                     zsc_f  = atfp * ( zsca   - 2.* zscn   + zscb   ) 
-                     !
-                     !                                         ! filtered tracer including the correction 
-                     ze3fr = 1.e0  / ( ze3t_n + ze3t_f )
-                     ztf   = ze3fr * ( ztcn   + ztc_f  )
-                     zsf   = ze3fr * ( zscn   + zsc_f  )
-                     !                                         ! mean thickness and tracer
-                     ze3mr = 1.e0  / ( ze3t_a + 2.* ze3t_n + ze3t_b )
-                     ztm   = ze3mr * ( ztca   + 2.* ztcn   + ztcb   )
-                     zsm   = ze3mr * ( zsca   + 2.* zscn   + zscb   )
-!!gm mean e3t have to be saved and used in dynhpg  or it can be recomputed in dynhpg !!
-!!gm                 e3t_m(ji,jj,jk) = 0.25 / ze3mr
-                     !                                         ! swap of arrays
-                     tb(ji,jj,jk) = ztf                             ! tb <-- tn + filter
-                     sb(ji,jj,jk) = zsf
-                     tn(ji,jj,jk) = ta(ji,jj,jk)                    ! tn <-- ta
-                     sn(ji,jj,jk) = sa(ji,jj,jk)
-                     ta(ji,jj,jk) = ztm                             ! ta <-- mean t
-                     sa(ji,jj,jk) = zsm
+            DO jn = 1, kjpt                               ! (only swap)
+               DO jk = 1, jpkm1
+                  DO jj = 1, jpj
+                     DO ji = 1, jpi
+                        ze3t_b = fse3t_b(ji,jj,jk)
+                        ze3t_n = fse3t_n(ji,jj,jk)
+                        ze3t_a = fse3t_a(ji,jj,jk)
+                        !                                         ! tracer content at Before, now and after
+                        ztcb = ptrab(ji,jj,jk,jn) *  ze3t_b  
+                        ztcn = ptran(ji,jj,jk,jn) *  ze3t_n  
+                        ztca = ptraa(ji,jj,jk,jn) *  ze3t_a  
+                        !
+                        !                                         ! Asselin filter on thickness and tracer content
+                        ze3t_f = atfp * ( ze3t_a - 2.* ze3t_n + ze3t_b )
+                        ztc_f  = atfp * ( ztca   - 2.* ztcn   + ztcb   ) 
+                        !
+                        !                                         ! filtered tracer including the correction 
+                        ze3fr = 1.e0  / ( ze3t_n + ze3t_f )
+                        ztf   = ze3fr * ( ztcn   + ztc_f  )
+                        !                                         ! mean thickness and tracer
+                        ze3mr = 1.e0  / ( ze3t_a + 2.* ze3t_n + ze3t_b )
+                        ztm   = ze3mr * ( ztca   + 2.* ztcn   + ztcb   )
+                        !!gm mean e3t have to be saved and used in dynhpg  or it can be recomputed in dynhpg !!
+                        !!gm                 e3t_m(ji,jj,jk) = 0.25 / ze3mr
+                        !                                         ! swap of arrays
+                        ptrab(ji,jj,jk,jn) = ztf                             ! ptrab <-- ptran + filter
+                        ptran(ji,jj,jk,jn) = ptraa(ji,jj,jk,jn)              ! ptran <-- ptraa
+                        ptraa(ji,jj,jk,jn) = ztm                             ! ptraa <-- mean t
+                     END DO
                   END DO
                END DO
@@ -341,10 +361,11 @@
          !                                           ! ----------------------- !
          !
-         IF( neuler == 0 .AND. kt == nit000 ) THEN        ! case of Euler time-stepping at first time-step
-            DO jk = 1, jpkm1                              ! No filter nor thickness weighting computation required
-               DO jj = 1, jpj                             ! ONLY swap
-                  DO ji = 1, jpi
-                     tn(ji,jj,jk) = ta(ji,jj,jk)                                 ! tn <-- ta
-                     sn(ji,jj,jk) = sa(ji,jj,jk)
+         IF( neuler == 0 .AND. kt == kit000 ) THEN        ! case of Euler time-stepping at first time-step
+            DO jn = 1, kjpt                               ! No filter nor thickness weighting computation required    
+               DO jk = 1, jpkm1                           ! ONLY swap                        
+                  DO jj = 1, jpj                             
+                     DO ji = 1, jpi
+                        ptran(ji,jj,jk,jn) = ptraa(ji,jj,jk,jn)                                 ! tn <-- ta
+                     END DO
                   END DO
                END DO
@@ -352,29 +373,27 @@
             !                                             ! general case (Leapfrog + Asselin filter)
          ELSE                                             ! apply filter on thickness weighted tracer and swap
-            DO jk = 1, jpkm1
-               DO jj = 1, jpj
-                  DO ji = 1, jpi
-                     ze3t_b = fse3t_b(ji,jj,jk)
-                     ze3t_n = fse3t_n(ji,jj,jk)
-                     ze3t_a = fse3t_a(ji,jj,jk)
-                     !                                         ! tracer content at Before, now and after
-                     ztcb = tb(ji,jj,jk) *  ze3t_b   ;   zscb = sb(ji,jj,jk) * ze3t_b
-                     ztcn = tn(ji,jj,jk) *  ze3t_n   ;   zscn = sn(ji,jj,jk) * ze3t_n
-                     ztca = ta(ji,jj,jk) *  ze3t_a   ;   zsca = sa(ji,jj,jk) * ze3t_a
-                     !
-                     !                                         ! Asselin filter on thickness and tracer content
-                     ze3t_f = atfp * ( ze3t_a - 2.* ze3t_n + ze3t_b )
-                     ztc_f  = atfp * ( ztca   - 2.* ztcn   + ztcb   ) 
-                     zsc_f  = atfp * ( zsca   - 2.* zscn   + zscb   ) 
-                     !
-                     !                                         ! filtered tracer including the correction 
-                     ze3fr = 1.e0 / ( ze3t_n + ze3t_f )
-                     ztf   =  ( ztcn  + ztc_f ) * ze3fr
-                     zsf   =  ( zscn  + zsc_f ) * ze3fr
-                     !                                         ! swap of arrays
-                     tb(ji,jj,jk) = ztf                             ! tb <-- tn filtered
-                     sb(ji,jj,jk) = zsf
-                     tn(ji,jj,jk) = ta(ji,jj,jk)                    ! tn <-- ta
-                     sn(ji,jj,jk) = sa(ji,jj,jk)
+            DO jn = 1, kjpt      
+               DO jk = 1, jpkm1
+                  DO jj = 1, jpj
+                     DO ji = 1, jpi
+                        ze3t_b = fse3t_b(ji,jj,jk)
+                        ze3t_n = fse3t_n(ji,jj,jk)
+                        ze3t_a = fse3t_a(ji,jj,jk)
+                        !                                         ! tracer content at Before, now and after
+                        ztcb = ptrab(ji,jj,jk,jn) *  ze3t_b  
+                        ztcn = ptran(ji,jj,jk,jn) *  ze3t_n   
+                        ztca = ptraa(ji,jj,jk,jn) *  ze3t_a  
+                        !
+                        !                                         ! Asselin filter on thickness and tracer content
+                        ze3t_f = atfp * ( ze3t_a - 2.* ze3t_n + ze3t_b )
+                        ztc_f  = atfp * ( ztca   - 2.* ztcn   + ztcb   ) 
+                        !
+                        !                                         ! filtered tracer including the correction 
+                        ze3fr = 1.e0 / ( ze3t_n + ze3t_f )
+                        ztf   =  ( ztcn  + ztc_f ) * ze3fr
+                        !                                         ! swap of arrays
+                        ptrab(ji,jj,jk,jn) = ztf                  ! tb <-- tn filtered
+                        ptran(ji,jj,jk,jn) = ptraa(ji,jj,jk,jn)   ! tn <-- ta
+                     END DO
                   END DO
                END DO
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traqsr.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 2023)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traqsr.F90	(revision 2024)
@@ -21,5 +21,5 @@
    USE trc_oce         ! share SMS/Ocean variables
    USE trdmod_oce      ! ocean variables trends
-   USE trdmod          ! ocean active tracers trends 
+   USE trdtra          ! ocean active tracers trends 
    USE in_out_manager  ! I/O manager
    USE phycst          ! physical constants
@@ -31,5 +31,6 @@
    PRIVATE
 
-   PUBLIC   tra_qsr        ! routine called by step.F90 (ln_traqsr=T)
+   PUBLIC   tra_qsr       ! routine called by step.F90 (ln_traqsr=T)
+   PUBLIC   tra_qsr_init  ! routine called by opa.F90
 
    !                                           !!* Namelist namtra_qsr: penetrative solar radiation
@@ -87,6 +88,4 @@
       !!              Lengaigne et al. 2007, Clim. Dyn., V28, 5, 503-516.
       !!----------------------------------------------------------------------
-      USE oce, ONLY :   ztrdt => ua   ! use ua as 3D workspace   
-      USE oce, ONLY :   ztrds => va   ! use va as 3D workspace   
       !!
       INTEGER, INTENT(in) ::   kt     ! ocean time-step
@@ -98,4 +97,5 @@
       REAL(wp), DIMENSION(jpi,jpj)     ::   zekb, zekg, zekr            ! 2D workspace
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ze0, ze1 , ze2, ze3, zea    ! 3D workspace
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ztrdt,  ztrds
       !!----------------------------------------------------------------------
 
@@ -104,13 +104,11 @@
          IF(lwp) WRITE(numout,*) 'tra_qsr : penetration of the surface solar radiation'
          IF(lwp) WRITE(numout,*) '~~~~~~~'
-         CALL tra_qsr_init
          IF( .NOT.ln_traqsr )   RETURN
       ENDIF
 
       IF( l_trdtra ) THEN      ! Save ta and sa trends
-         ztrdt(:,:,:) = ta(:,:,:) 
-         ztrds(:,:,:) = 0.e0
-      ENDIF
-
+         ALLOCATE( ztrdt(jpi,jpj,jpk) )   ;    ztrdt(:,:,:) = tsa(:,:,:,jp_tem)
+         ALLOCATE( ztrds(jpi,jpj,jpk) )   ;    ztrds(:,:,:) = 0.
+      ENDIF
       
       !                                           ! ============================================== !
@@ -177,5 +175,5 @@
                !
                DO jk = 1, nksr                                        ! compute and add qsr trend to ta
-                  ta(:,:,jk) = ta(:,:,jk) + ro0cpr * ( zea(:,:,jk) - zea(:,:,jk+1) ) / fse3t(:,:,jk)
+                  tsa(:,:,jk,jp_tem) = tsa(:,:,jk,jp_tem) + ro0cpr * ( zea(:,:,jk) - zea(:,:,jk+1) ) / fse3t(:,:,jk)
                END DO
                zea(:,:,nksr+1:jpk) = 0.e0     ! below 400m set to zero
@@ -184,5 +182,5 @@
             ELSE                                                 !*  Constant Chlorophyll
                DO jk = 1, nksr
-                  ta(:,:,jk) = ta(:,:,jk) + etot3(:,:,jk) * qsr(:,:)
+                  tsa(:,:,jk,jp_tem) = tsa(:,:,jk,jp_tem) + etot3(:,:,jk) * qsr(:,:)
                END DO
             ENDIF
@@ -196,5 +194,5 @@
                DO jj = 2, jpjm1
                   DO ji = fs_2, fs_jpim1   ! vector opt.
-                     ta(ji,jj,jk) = ta(ji,jj,jk) + etot3(ji,jj,jk) * qsr(ji,jj)
+                     tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + etot3(ji,jj,jk) * qsr(ji,jj)
                   END DO
                END DO
@@ -206,9 +204,11 @@
 
       IF( l_trdtra ) THEN     ! qsr tracers trends saved for diagnostics
-         ztrdt(:,:,:) = ta(:,:,:) - ztrdt(:,:,:)
-         CALL trd_mod( ztrdt, ztrds, jptra_trd_qsr, 'TRA', kt )
+         ztrdt(:,:,:) = tsa(:,:,:,jp_tem) - ztrdt(:,:,:)
+         CALL trd_tra( kt, 'TRA', jp_tem, jptra_trd_qsr, ztrdt )
+         CALL trd_tra( kt, 'TRA', jp_sal, jptra_trd_qsr, ztrds )
+         DEALLOCATE( ztrdt )    ;        DEALLOCATE( ztrds )
       ENDIF
       !                       ! print mean trends (used for debugging)
-      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' qsr  - Ta: ', mask1=tmask, clinfo3='tra-ta' )
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' qsr  - Ta: ', mask1=tmask, clinfo3='tra-ta' )
       !
    END SUBROUTINE tra_qsr
